'' =================================================================================================
''
''   File....... jm_esc_demo.spin
''   Purpose.... 
''   Author..... Jon "JonnyMac" McPhalen (aka Jon Williams)
''               Copyright (c) 2011 Jon McPhalen
''               -- see below for terms of use
''   E-mail..... jon@jonmcphalen.com
''   Started.... 
''   Updated.... 
''
'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal
' _xinfreq = 6_250_000                                          ' use 6.25MHz crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000


con

  RX1 = 31
  TX1 = 30
  SDA = 29
  SCL = 28

  CH2 = 17
  CH1 = 16


con

  ESC_MIN = 1_000
  ESC_MAX = 2_000

  DELTA   = 100                                                   


con

   #1, HOME, GOTOXY, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR       ' PST formmatting control
  #14, GOTOX, GOTOY, CLS


obj

  esc  : "jm_servo8_adv"
  term : "fullduplexserial64"
 

var


dat

Menu            byte    "ESC Control      speed", CR
                byte    "----------------------", CR
                byte    CR
                byte    "[1] ESC1 -            ", CR
                byte    "[2] ESC1 +            ", CR
                byte    "[3] ESC2 -            ", CR
                byte    "[4] ESC2 +            ", CR
                byte    0


pub main | speed1, speed2, c

  esc.startx(2, CH1, ESC_MIN, ESC_MAX, ESC_MIN)                 ' start ESC driver (2 channels)
  term.start(RX1, TX1, %0000, 115_200)                          ' start serial IO
  pause(1)

  speed1 := speed2 := ESC_MIN

  repeat
    term.tx(CLS)                                                ' refesh screen
    term.str(@Menu)
    moveto(18, 3)
    term.rjdec(speed1, 4)
    moveto(18, 5)
    term.rjdec(speed2, 4)
       
    term.rxflush 
    c := term.rx                                                ' wait for command
    
    case c
      "1":
        speed1 -= DELTA                                         ' decrement
        speed1 #>= ESC_MIN                                      ' keep legal
        esc.set(0, speed1, 0)                                   ' set new level
                                                                 
      "2":                                                       
        speed1 += DELTA                                         ' incrment
        speed1 <#= ESC_MAX                                      ' keep legal
        esc.set(0, speed1, 0)                                   ' set new level

      "3":
        speed2 -= DELTA
        speed2 #>= ESC_MIN
        esc.set(1, speed2, 0)

      "4":
        speed2 += DELTA
        speed2 <#= ESC_MAX
        esc.set(1, speed2, 0)
    

pub pause(ms) | t

'' Delay program ms milliseconds

  t := cnt - 1088                                               ' sync with system counter
  repeat (ms #> 0)                                              ' delay must be > 0
    waitcnt(t += MS_001)


pub moveto(x, y)

'' Moves cursor on PST

  term.tx(GOTOXY)
  term.tx(x)
  term.tx(y)


dat

{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}